Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/optimization.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs	(revision 7294)
@@ -2995,7 +10200,11 @@
             public double[] gbase;
             public double[,] quadraticmodel;
+            public double[] bndl;
+            public double[] bndu;
+            public bool[] havebndl;
+            public bool[] havebndu;
+            public double[] s;
             public double lambdav;
             public double nu;
-            public double[,] dampedmodel;
             public int modelage;
             public double[] xdir;
@@ -3013,12 +10222,15 @@
             public rcommstate rstate;
             public double[] choleskybuf;
+            public double[] tmp0;
             public double actualdecrease;
             public double predicteddecrease;
-            public double[] fm2;
+            public double xm1;
+            public double xp1;
             public double[] fm1;
-            public double[] fp2;
             public double[] fp1;
             public minlbfgs.minlbfgsstate internalstate;
             public minlbfgs.minlbfgsreport internalrep;
+            public minqp.minqpstate qpstate;
+            public minqp.minqpreport qprep;
             public minlmstate()
             {
@@ -3032,5 +10244,9 @@
                 gbase = new double[0];
                 quadraticmodel = new double[0,0];
-                dampedmodel = new double[0,0];
+                bndl = new double[0];
+                bndu = new double[0];
+                havebndl = new bool[0];
+                havebndu = new bool[0];
+                s = new double[0];
                 xdir = new double[0];
                 deltax = new double[0];
@@ -3038,10 +10254,11 @@
                 rstate = new rcommstate();
                 choleskybuf = new double[0];
-                fm2 = new double[0];
+                tmp0 = new double[0];
                 fm1 = new double[0];
-                fp2 = new double[0];
                 fp1 = new double[0];
                 internalstate = new minlbfgs.minlbfgsstate();
                 internalrep = new minlbfgs.minlbfgsreport();
+                qpstate = new minqp.minqpstate();
+                qprep = new minqp.minqpreport();
             }
         };
@@ -3382,206 +10599,4 @@
 
         /*************************************************************************
-                        IMPROVED LEVENBERG-MARQUARDT METHOD FOR
-                         NON-LINEAR LEAST SQUARES OPTIMIZATION
-
-        DESCRIPTION:
-        This function is used to find minimum of function which is represented  as
-        sum of squares:
-            F(x) = f[0]^2(x[0],...,x[n-1]) + ... + f[m-1]^2(x[0],...,x[n-1])
-        using:
-        * value of function vector f[]
-        * value of Jacobian of f[]
-        * gradient of merit function F(x)
-
-        This function creates optimizer which uses acceleration strategy 2.  Cheap
-        gradient of merit function (which is twice the product of function  vector
-        and Jacobian) is used for accelerated iterations (see User Guide for  more
-        info on this subject).
-
-        REQUIREMENTS:
-        This algorithm will request following information during its operation:
-
-        * function vector f[] at given point X
-        * function vector f[] and Jacobian of f[] (simultaneously) at given point
-        * gradient of
-
-        There are several overloaded versions of  MinLMOptimize()  function  which
-        correspond  to  different LM-like optimization algorithms provided by this
-        unit. You should choose version which accepts  fvec(),  jac()  and  grad()
-        callbacks. First one is used to calculate f[] at given point,  second  one
-        calculates f[] and Jacobian df[i]/dx[j], last one calculates  gradient  of
-        merit function F(x).
-
-        You can try to initialize MinLMState structure with VJ  function and  then
-        use incorrect version  of  MinLMOptimize()  (for  example,  version  which
-        works  with  general  form function and does not provide Jacobian), but it
-        will  lead  to  exception  being  thrown  after first attempt to calculate
-        Jacobian.
-
-
-        USAGE:
-        1. User initializes algorithm state with MinLMCreateVGJ() call
-        2. User tunes solver parameters with MinLMSetCond(),  MinLMSetStpMax() and
-           other functions
-        3. User calls MinLMOptimize() function which  takes algorithm  state   and
-           callback functions.
-        4. User calls MinLMResults() to get solution
-        5. Optionally, user may call MinLMRestartFrom() to solve  another  problem
-           with same N/M but another starting point and/or another function.
-           MinLMRestartFrom() allows to reuse already initialized structure.
-
-
-        INPUT PARAMETERS:
-            N       -   dimension, N>1
-                        * if given, only leading N elements of X are used
-                        * if not given, automatically determined from size of X
-            M       -   number of functions f[i]
-            X       -   initial solution, array[0..N-1]
-
-        OUTPUT PARAMETERS:
-            State   -   structure which stores algorithm state
-
-        NOTES:
-        1. you may tune stopping conditions with MinLMSetCond() function
-        2. if target function contains exp() or other fast growing functions,  and
-           optimization algorithm makes too large steps which leads  to  overflow,
-           use MinLMSetStpMax() function to bound algorithm's steps.
-
-          -- ALGLIB --
-             Copyright 30.03.2009 by Bochkanov Sergey
-        *************************************************************************/
-        public static void minlmcreatevgj(int n,
-            int m,
-            double[] x,
-            minlmstate state)
-        {
-            ap.assert(n>=1, "MinLMCreateVGJ: N<1!");
-            ap.assert(m>=1, "MinLMCreateVGJ: M<1!");
-            ap.assert(ap.len(x)>=n, "MinLMCreateVGJ: Length(X)<N!");
-            ap.assert(apserv.isfinitevector(x, n), "MinLMCreateVGJ: X contains infinite or NaN values!");
-            
-            //
-            // initialize, check parameters
-            //
-            state.n = n;
-            state.m = m;
-            state.algomode = 1;
-            state.hasf = false;
-            state.hasfi = true;
-            state.hasg = false;
-            
-            //
-            // second stage of initialization
-            //
-            lmprepare(n, m, false, state);
-            minlmsetacctype(state, 2);
-            minlmsetcond(state, 0, 0, 0, 0);
-            minlmsetxrep(state, false);
-            minlmsetstpmax(state, 0);
-            minlmrestartfrom(state, x);
-        }
-
-
-        /*************************************************************************
-                           LEVENBERG-MARQUARDT-LIKE METHOD FOR
-                          NON-LINEAR LEAST SQUARES OPTIMIZATION
-
-        DESCRIPTION:
-
-        This function is used to find minimum of function which is represented  as
-        sum of squares:
-            F(x) = f[0]^2(x[0],...,x[n-1]) + ... + f[m-1]^2(x[0],...,x[n-1])
-        using value of F(), gradient of F(), function vector f[]  and  Jacobian of
-        f[].
-
-        This function is considered obsolete since ALGLIB 3.1.0 and is present for
-        backward  compatibility  only.  We  recommend to use MinLMCreateVGJ, which
-        provides similar, but more consistent interface.
-
-          -- ALGLIB --
-             Copyright 30.03.2009 by Bochkanov Sergey
-        *************************************************************************/
-        public static void minlmcreatefgj(int n,
-            int m,
-            double[] x,
-            minlmstate state)
-        {
-            ap.assert(n>=1, "MinLMCreateFGJ: N<1!");
-            ap.assert(m>=1, "MinLMCreateFGJ: M<1!");
-            ap.assert(ap.len(x)>=n, "MinLMCreateFGJ: Length(X)<N!");
-            ap.assert(apserv.isfinitevector(x, n), "MinLMCreateFGJ: X contains infinite or NaN values!");
-            
-            //
-            // initialize
-            //
-            state.n = n;
-            state.m = m;
-            state.algomode = 1;
-            state.hasf = true;
-            state.hasfi = false;
-            state.hasg = true;
-            
-            //
-            // init2
-            //
-            lmprepare(n, m, true, state);
-            minlmsetacctype(state, 2);
-            minlmsetcond(state, 0, 0, 0, 0);
-            minlmsetxrep(state, false);
-            minlmsetstpmax(state, 0);
-            minlmrestartfrom(state, x);
-        }
-
-
-        /*************************************************************************
-            CLASSIC LEVENBERG-MARQUARDT METHOD FOR NON-LINEAR OPTIMIZATION
-
-        DESCRIPTION:
-        This function is used to find minimum of function which is represented  as
-        sum of squares:
-            F(x) = f[0]^2(x[0],...,x[n-1]) + ... + f[m-1]^2(x[0],...,x[n-1])
-        using  value  of  F(),  function  vector  f[] and Jacobian of f[]. Classic
-        Levenberg-Marquardt method is used.
-
-        This function is considered obsolete since ALGLIB 3.1.0 and is present for
-        backward  compatibility  only.  We  recommend  to use MinLMCreateVJ, which
-        provides similar, but more consistent and feature-rich interface.
-
-          -- ALGLIB --
-             Copyright 30.03.2009 by Bochkanov Sergey
-        *************************************************************************/
-        public static void minlmcreatefj(int n,
-            int m,
-            double[] x,
-            minlmstate state)
-        {
-            ap.assert(n>=1, "MinLMCreateFJ: N<1!");
-            ap.assert(m>=1, "MinLMCreateFJ: M<1!");
-            ap.assert(ap.len(x)>=n, "MinLMCreateFJ: Length(X)<N!");
-            ap.assert(apserv.isfinitevector(x, n), "MinLMCreateFJ: X contains infinite or NaN values!");
-            
-            //
-            // initialize
-            //
-            state.n = n;
-            state.m = m;
-            state.algomode = 1;
-            state.hasf = true;
-            state.hasfi = false;
-            state.hasg = false;
-            
-            //
-            // init 2
-            //
-            lmprepare(n, m, true, state);
-            minlmsetacctype(state, 0);
-            minlmsetcond(state, 0, 0, 0, 0);
-            minlmsetxrep(state, false);
-            minlmsetstpmax(state, 0);
-            minlmrestartfrom(state, x);
-        }
-
-
-        /*************************************************************************
         This function sets stopping conditions for Levenberg-Marquardt optimization
         algorithm.
@@ -3591,6 +10606,9 @@
             EpsG    -   >=0
                         The  subroutine  finishes  its  work   if   the  condition
-                        ||G||<EpsG is satisfied, where ||.|| means Euclidian norm,
-                        G - gradient.
+                        |v|<EpsG is satisfied, where:
+                        * |.| means Euclidian norm
+                        * v - scaled gradient vector, v[i]=g[i]*s[i]
+                        * g - gradient
+                        * s - scaling coefficients set by MinLMSetScale()
             EpsF    -   >=0
                         The  subroutine  finishes  its work if on k+1-th iteration
@@ -3599,5 +10617,9 @@
             EpsX    -   >=0
                         The subroutine finishes its work if  on  k+1-th  iteration
-                        the condition |X(k+1)-X(k)| <= EpsX is fulfilled.
+                        the condition |v|<=EpsX is fulfilled, where:
+                        * |.| means Euclidian norm
+                        * v - scaled step vector, v[i]=dx[i]/s[i]
+                        * dx - ste pvector, dx=X(k+1)-X(k)
+                        * s - scaling coefficients set by MinLMSetScale()
             MaxIts  -   maximum number of iterations. If MaxIts=0, the  number  of
                         iterations   is    unlimited.   Only   Levenberg-Marquardt
@@ -3688,4 +10710,96 @@
 
         /*************************************************************************
+        This function sets scaling coefficients for LM optimizer.
+
+        ALGLIB optimizers use scaling matrices to test stopping  conditions  (step
+        size and gradient are scaled before comparison with tolerances).  Scale of
+        the I-th variable is a translation invariant measure of:
+        a) "how large" the variable is
+        b) how large the step should be to make significant changes in the function
+
+        Generally, scale is NOT considered to be a form of preconditioner.  But LM
+        optimizer is unique in that it uses scaling matrix both  in  the  stopping
+        condition tests and as Marquardt damping factor.
+
+        Proper scaling is very important for the algorithm performance. It is less
+        important for the quality of results, but still has some influence (it  is
+        easier  to  converge  when  variables  are  properly  scaled, so premature
+        stopping is possible when very badly scalled variables are  combined  with
+        relaxed stopping conditions).
+
+        INPUT PARAMETERS:
+            State   -   structure stores algorithm state
+            S       -   array[N], non-zero scaling coefficients
+                        S[i] may be negative, sign doesn't matter.
+
+          -- ALGLIB --
+             Copyright 14.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minlmsetscale(minlmstate state,
+            double[] s)
+        {
+            int i = 0;
+
+            ap.assert(ap.len(s)>=state.n, "MinLMSetScale: Length(S)<N");
+            for(i=0; i<=state.n-1; i++)
+            {
+                ap.assert(math.isfinite(s[i]), "MinLMSetScale: S contains infinite or NAN elements");
+                ap.assert((double)(s[i])!=(double)(0), "MinLMSetScale: S contains zero elements");
+                state.s[i] = Math.Abs(s[i]);
+            }
+        }
+
+
+        /*************************************************************************
+        This function sets boundary constraints for LM optimizer
+
+        Boundary constraints are inactive by default (after initial creation).
+        They are preserved until explicitly turned off with another SetBC() call.
+
+        INPUT PARAMETERS:
+            State   -   structure stores algorithm state
+            BndL    -   lower bounds, array[N].
+                        If some (all) variables are unbounded, you may specify
+                        very small number or -INF (latter is recommended because
+                        it will allow solver to use better algorithm).
+            BndU    -   upper bounds, array[N].
+                        If some (all) variables are unbounded, you may specify
+                        very large number or +INF (latter is recommended because
+                        it will allow solver to use better algorithm).
+
+        NOTE 1: it is possible to specify BndL[i]=BndU[i]. In this case I-th
+        variable will be "frozen" at X[i]=BndL[i]=BndU[i].
+
+        NOTE 2: this solver has following useful properties:
+        * bound constraints are always satisfied exactly
+        * function is evaluated only INSIDE area specified by bound constraints
+          or at its boundary
+
+          -- ALGLIB --
+             Copyright 14.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minlmsetbc(minlmstate state,
+            double[] bndl,
+            double[] bndu)
+        {
+            int i = 0;
+            int n = 0;
+
+            n = state.n;
+            ap.assert(ap.len(bndl)>=n, "MinLMSetBC: Length(BndL)<N");
+            ap.assert(ap.len(bndu)>=n, "MinLMSetBC: Length(BndU)<N");
+            for(i=0; i<=n-1; i++)
+            {
+                ap.assert(math.isfinite(bndl[i]) | Double.IsNegativeInfinity(bndl[i]), "MinLMSetBC: BndL contains NAN or +INF");
+                ap.assert(math.isfinite(bndu[i]) | Double.IsPositiveInfinity(bndu[i]), "MinLMSetBC: BndU contains NAN or -INF");
+                state.bndl[i] = bndl[i];
+                state.havebndl[i] = math.isfinite(bndl[i]);
+                state.bndu[i] = bndu[i];
+                state.havebndu[i] = math.isfinite(bndu[i]);
+            }
+        }
+
+
+        /*************************************************************************
         This function is used to change acceleration settings
 
@@ -3698,6 +10812,4 @@
           settings: about 3 iterations - when we have analytic Jacobian, up to 2*N
           iterations - when we use finite differences to calculate Jacobian.
-        * AccType=2, after quadratic model is built and LM step is made, we use it
-          as preconditioner for several (5-10) iterations of L-BFGS algorithm.
 
         AccType=1 is recommended when Jacobian  calculation  cost  is  prohibitive
@@ -3707,9 +10819,4 @@
         approximation takes too much time to compute.
 
-        AccType=2 is recommended when Jacobian is cheap - much more  cheaper  than
-        one  Cholesky  factorization.   We   can   reduce   number   of   Cholesky
-        factorizations at the cost of increased number of  Jacobian  calculations.
-        Sometimes it helps.
-
         Table below list  optimization  protocols  (XYZ  protocol  corresponds  to
         MinLMCreateXYZ) and acceleration types they support (and use by  default).
@@ -3717,21 +10824,15 @@
         ACCELERATION TYPES SUPPORTED BY OPTIMIZATION PROTOCOLS:
 
-        protocol    0   1   2   comment
+        protocol    0   1   comment
         V           +   +
-        VJ          +   +   +
-        FGH         +       +
-        VGJ         +   +   +   special protocol, not for widespread use
-        FJ          +       +   obsolete protocol, not recommended
-        FGJ         +       +   obsolete protocol, not recommended
+        VJ          +   +
+        FGH         +
 
         DAFAULT VALUES:
 
-        protocol    0   1   2   comment
-        V               x       without acceleration it is so slooooooooow
+        protocol    0   1   comment
+        V               x   without acceleration it is so slooooooooow
         VJ          x
         FGH         x
-        VGJ                 x   we've implicitly turned (2) by passing gradient
-        FJ          x           obsolete protocol, not recommended
-        FGJ                 x   obsolete protocol, not recommended
 
         NOTE: this  function should be called before optimization. Attempt to call
@@ -3748,4 +10849,8 @@
         {
             ap.assert((acctype==0 | acctype==1) | acctype==2, "MinLMSetAccType: incorrect AccType!");
+            if( acctype==2 )
+            {
+                acctype = 0;
+            }
             if( acctype==0 )
             {
@@ -3766,11 +10871,4 @@
                 }
                 state.makeadditers = false;
-                return;
-            }
-            if( acctype==2 )
-            {
-                ap.assert(state.algomode==1 | state.algomode==2, "MinLMSetAccType: AccType=2 is incompatible with current protocol!");
-                state.maxmodelage = 0;
-                state.makeadditers = true;
                 return;
             }
@@ -3910,12 +11008,4 @@
                 goto lbl_15;
             }
-            if( state.rstate.stage==16 )
-            {
-                goto lbl_16;
-            }
-            if( state.rstate.stage==17 )
-            {
-                goto lbl_17;
-            }
             
             //
@@ -3937,4 +11027,22 @@
             
             //
+            // check consistency of constraints
+            // set constraints
+            //
+            for(i=0; i<=n-1; i++)
+            {
+                if( state.havebndl[i] & state.havebndu[i] )
+                {
+                    if( (double)(state.bndl[i])>(double)(state.bndu[i]) )
+                    {
+                        state.repterminationtype = -3;
+                        result = false;
+                        return result;
+                    }
+                }
+            }
+            minqp.minqpsetbc(state.qpstate, state.bndl, state.bndu);
+            
+            //
             // Initial report of current point
             //
@@ -3947,5 +11055,5 @@
             if( !state.xrep )
             {
-                goto lbl_18;
+                goto lbl_16;
             }
             for(i_=0; i_<=n-1;i_++)
@@ -3956,5 +11064,5 @@
             if( !state.hasf )
             {
-                goto lbl_20;
+                goto lbl_18;
             }
             state.needf = true;
@@ -3963,6 +11071,6 @@
         lbl_0:
             state.needf = false;
-            goto lbl_21;
-        lbl_20:
+            goto lbl_19;
+        lbl_18:
             ap.assert(state.hasfi, "MinLM: internal error 2!");
             state.needfi = true;
@@ -3977,5 +11085,5 @@
             }
             state.f = v;
-        lbl_21:
+        lbl_19:
             state.repnfunc = state.repnfunc+1;
             for(i_=0; i_<=n-1;i_++)
@@ -3989,5 +11097,5 @@
         lbl_2:
             state.xupdated = false;
-        lbl_18:
+        lbl_16:
             
             //
@@ -4009,8 +11117,8 @@
             //
             //
-        lbl_22:
+        lbl_20:
             if( false )
             {
-                goto lbl_23;
+                goto lbl_21;
             }
             
@@ -4040,21 +11148,21 @@
             if( !(state.algomode==0 | state.algomode==1) )
             {
+                goto lbl_22;
+            }
+            
+            //
+            // Calculate f[] and Jacobian
+            //
+            if( !(state.modelage>state.maxmodelage | !(state.deltaxready & state.deltafready)) )
+            {
                 goto lbl_24;
             }
             
             //
-            // Calculate f[] and Jacobian
-            //
-            if( !(state.modelage>state.maxmodelage | !(state.deltaxready & state.deltafready)) )
+            // Refresh model (using either finite differences or analytic Jacobian)
+            //
+            if( state.algomode!=0 )
             {
                 goto lbl_26;
-            }
-            
-            //
-            // Refresh model (using either finite differences or analytic Jacobian)
-            //
-            if( state.algomode!=0 )
-            {
-                goto lbl_28;
             }
             
@@ -4065,14 +11173,28 @@
             ap.assert(state.hasfi, "MinLMIteration: internal error when estimating Jacobian (no f[])");
             k = 0;
-        lbl_30:
+        lbl_28:
             if( k>n-1 )
             {
-                goto lbl_32;
-            }
+                goto lbl_30;
+            }
+            
+            //
+            // We guard X[k] from leaving [BndL,BndU].
+            // In case BndL=BndU, we assume that derivative in this direction is zero.
+            //
             for(i_=0; i_<=n-1;i_++)
             {
                 state.x[i_] = state.xbase[i_];
             }
-            state.x[k] = state.x[k]-state.diffstep;
+            state.x[k] = state.x[k]-state.s[k]*state.diffstep;
+            if( state.havebndl[k] )
+            {
+                state.x[k] = Math.Max(state.x[k], state.bndl[k]);
+            }
+            if( state.havebndu[k] )
+            {
+                state.x[k] = Math.Min(state.x[k], state.bndu[k]);
+            }
+            state.xm1 = state.x[k];
             clearrequestfields(state);
             state.needfi = true;
@@ -4089,5 +11211,14 @@
                 state.x[i_] = state.xbase[i_];
             }
-            state.x[k] = state.x[k]+state.diffstep;
+            state.x[k] = state.x[k]+state.s[k]*state.diffstep;
+            if( state.havebndl[k] )
+            {
+                state.x[k] = Math.Max(state.x[k], state.bndl[k]);
+            }
+            if( state.havebndu[k] )
+            {
+                state.x[k] = Math.Min(state.x[k], state.bndu[k]);
+            }
+            state.xp1 = state.x[k];
             clearrequestfields(state);
             state.needfi = true;
@@ -4100,16 +11231,27 @@
                 state.fp1[i_] = state.fi[i_];
             }
-            v = 1/(2*state.diffstep);
-            for(i_=0; i_<=m-1;i_++)
-            {
-                state.j[i_,k] = v*state.fp1[i_];
-            }
-            for(i_=0; i_<=m-1;i_++)
-            {
-                state.j[i_,k] = state.j[i_,k] - v*state.fm1[i_];
+            v = state.xp1-state.xm1;
+            if( (double)(v)!=(double)(0) )
+            {
+                v = 1/v;
+                for(i_=0; i_<=m-1;i_++)
+                {
+                    state.j[i_,k] = v*state.fp1[i_];
+                }
+                for(i_=0; i_<=m-1;i_++)
+                {
+                    state.j[i_,k] = state.j[i_,k] - v*state.fm1[i_];
+                }
+            }
+            else
+            {
+                for(i=0; i<=m-1; i++)
+                {
+                    state.j[i,k] = 0;
+                }
             }
             k = k+1;
-            goto lbl_30;
-        lbl_32:
+            goto lbl_28;
+        lbl_30:
             
             //
@@ -4133,6 +11275,6 @@
             //
             state.modelage = 0;
-            goto lbl_29;
-        lbl_28:
+            goto lbl_27;
+        lbl_26:
             
             //
@@ -4156,7 +11298,7 @@
             //
             state.modelage = 0;
-        lbl_29:
-            goto lbl_27;
-        lbl_26:
+        lbl_27:
+            goto lbl_25;
+        lbl_24:
             
             //
@@ -4211,5 +11353,5 @@
             //
             state.modelage = state.modelage+1;
-        lbl_27:
+        lbl_25:
             
             //
@@ -4245,8 +11387,8 @@
             //
             bflag = true;
-        lbl_24:
+        lbl_22:
             if( state.algomode!=2 )
             {
-                goto lbl_33;
+                goto lbl_31;
             }
             ap.assert(!state.hasfi, "MinLMIteration: internal error (HasFI is True in Hessian-based mode)");
@@ -4280,5 +11422,5 @@
             bflag = true;
             state.modelage = 0;
-        lbl_33:
+        lbl_31:
             ap.assert(bflag, "MinLM: internal integrity check failed!");
             state.deltaxready = false;
@@ -4293,5 +11435,5 @@
                 for(i=0; i<=n-1; i++)
                 {
-                    state.lambdav = Math.Max(state.lambdav, Math.Abs(state.quadraticmodel[i,i]));
+                    state.lambdav = Math.Max(state.lambdav, Math.Abs(state.quadraticmodel[i,i])*math.sqr(state.s[i]));
                 }
                 state.lambdav = 0.001*state.lambdav;
@@ -4305,17 +11447,11 @@
             // Test stopping conditions for function gradient
             //
-            v = 0.0;
-            for(i_=0; i_<=n-1;i_++)
-            {
-                v += state.gbase[i_]*state.gbase[i_];
-            }
-            v = Math.Sqrt(v);
-            if( (double)(v)>(double)(state.epsg) )
+            if( (double)(boundedscaledantigradnorm(state, state.xbase, state.gbase))>(double)(state.epsg) )
+            {
+                goto lbl_33;
+            }
+            if( state.modelage!=0 )
             {
                 goto lbl_35;
-            }
-            if( state.modelage!=0 )
-            {
-                goto lbl_37;
             }
             
@@ -4326,5 +11462,5 @@
             if( !state.xrep )
             {
-                goto lbl_39;
+                goto lbl_37;
             }
             for(i_=0; i_<=n-1;i_++)
@@ -4339,9 +11475,9 @@
         lbl_8:
             state.xupdated = false;
-        lbl_39:
+        lbl_37:
             result = false;
             return result;
-            goto lbl_38;
-        lbl_37:
+            goto lbl_36;
+        lbl_35:
             
             //
@@ -4350,7 +11486,7 @@
             //
             state.modelage = state.maxmodelage+1;
-            goto lbl_22;
-        lbl_38:
-        lbl_35:
+            goto lbl_20;
+        lbl_36:
+        lbl_33:
             
             //
@@ -4361,4 +11497,5 @@
             //
             // After this block IFlag is set to:
+            // * -3, if constraints are infeasible
             // * -2, if model update is needed (either Lambda growth is too large
             //       or step is too short, but we can't rely on model and stop iterations)
@@ -4369,8 +11506,8 @@
             //
             iflag = -99;
-        lbl_41:
+        lbl_39:
             if( false )
             {
-                goto lbl_42;
+                goto lbl_40;
             }
             
@@ -4381,21 +11518,11 @@
             {
                 iflag = -2;
-                goto lbl_42;
-            }
-            
-            //
-            // DampedModel = QuadraticModel+lambda*I
-            //
-            ablas.rmatrixcopy(n, n, state.quadraticmodel, 0, 0, ref state.dampedmodel, 0, 0);
-            for(i=0; i<=n-1; i++)
-            {
-                state.dampedmodel[i,i] = state.dampedmodel[i,i]+state.lambdav;
-            }
-            
-            //
-            // 1. try to solve (RawModel+Lambda*I)*dx = -g.
-            //    increase lambda if left part is not positive definite.
-            // 2. bound step by StpMax
-            //    increase lambda if step is larger than StpMax
+                goto lbl_40;
+            }
+            
+            //
+            // Setup quadratic solver and solve quadratic programming problem.
+            // After problem is solved we'll try to bound step by StpMax
+            // (Lambda will be increased if step size is too large).
             //
             // We use BFlag variable to indicate that we have to increase Lambda.
@@ -4403,12 +11530,25 @@
             //
             bflag = true;
-            state.repncholesky = state.repncholesky+1;
-            if( trfac.spdmatrixcholeskyrec(ref state.dampedmodel, 0, n, true, ref state.choleskybuf) )
-            {
+            minqp.minqpsetstartingpointfast(state.qpstate, state.xbase);
+            minqp.minqpsetoriginfast(state.qpstate, state.xbase);
+            minqp.minqpsetlineartermfast(state.qpstate, state.gbase);
+            minqp.minqpsetquadratictermfast(state.qpstate, state.quadraticmodel, true, 0.0);
+            for(i=0; i<=n-1; i++)
+            {
+                state.tmp0[i] = state.quadraticmodel[i,i]+state.lambdav/math.sqr(state.s[i]);
+            }
+            minqp.minqprewritediagonal(state.qpstate, state.tmp0);
+            minqp.minqpoptimize(state.qpstate);
+            minqp.minqpresultsbuf(state.qpstate, ref state.xdir, state.qprep);
+            if( state.qprep.terminationtype>0 )
+            {
+                
+                //
+                // successful solution of QP problem
+                //
                 for(i_=0; i_<=n-1;i_++)
                 {
-                    state.xdir[i_] = -state.gbase[i_];
-                }
-                fbls.fblscholeskysolve(state.dampedmodel, 1.0, n, true, ref state.xdir, ref state.choleskybuf);
+                    state.xdir[i_] = state.xdir[i_] - state.xbase[i_];
+                }
                 v = 0.0;
                 for(i_=0; i_<=n-1;i_++)
